#ifndef VASSILIS_NEW_CODE_H
#define VASSILIS_NEW_CODE_H

#include "algebra.h"


// returns a matrix with two columns. Each row represents a point,
// column 0 is the row, column 1 is the col of that point. length
// is the length of the longer side of the rectangle, and with
// is the length of the shorter side. Orientation is the direction of 
// the longer side, in radians.
float_matrix rectangle_pixels(float center_vertical, float center_horizontal, 
                              long length, long width, float orientation);


// returns a matrix with two columns. Each row represents a point,
// column 0 is the row, column 1 is the col of that point. length
// is the length of the longer side of the rectangle, and with
// is the length of the shorter side. Orientation is the direction of 
// the longer side, in radians.
long_matrix rectangle_pixels(long center_vertical, long center_horizontal, 
                                     long length, long width, float orientation);


// returns a matrix with three columns. Each row represents a point,
// column 0 is the row, column 1 is the col of that point, column 2
// is the weight of that point. length
// is the length of the longer side of the rectangle, and with
// is the length of the shorter side. Orientation is the direction of 
// the longer side, in radians. The weights sum up to one.
float_matrix rectangle_pixels_factors(long center_vertical, long center_horizontal, 
                                      long length, long width, float orientation);


class precomputed_rectangle_pixels
{
protected:
  long length;
  long width;
  long number_of_orientations;
  std::vector<float_matrix> rectangles;

public:
  precomputed_rectangle_pixels(long argument_length, long argument_width, 
                               long argument_number);
  ~precomputed_rectangle_pixels();

  long orientation_index(float radians);
  const float_matrix & rectangle(float radians);
};


long function_portion(long counter, long steps, long total);















#endif // VASSILIS_NEW_CODE_H
