#ifndef VASSILIS_READ_AVI_H
#define VASSILIS_READ_AVI_H

#include <stdio.h>

#include "auxiliaries.h"
#include "image.h"
#include "video_file.h"

class vAVITimeStamp;

class vReadAVI : public vVideoFile
{
private:
  long bytes_per_pixel;
  long bytes_per_frame;

  long frame_displacement;
  long initial_offset;
  
  vArray(uchar) ReadCurrentFrame();
  long ReadLong();
  ushort GotoFrame(long frame);

public:
  vReadAVI(const char * filename);
  ~vReadAVI();

  grayscale_image * ReadNextFrameGray();
  grayscale_image * ReadFrameGray(long number);
  color_image * ReadFrame(long number);
  color_image * ReadNextFrame();
  ushort InitializeWriting();
  ushort write_frame(color_image * image);
  ushort write_frameGray(grayscale_image * gray);
  ushort FinishWriting();

  vArray(uchar) ReadFrameBuffer(long number);
  vArray(uchar) GetPreamble();
  long InitialOffset();
  virtual long BytesPerPixel();
  long BytesPerFrame();

  static const long frame_header;
  static const long LengthLocation;
  static const long ScaleLocation;
  static const long RateLocation;

  vArray(uchar) ReadTextFrame(long number);
  vAVITimeStamp * ReadTimeStamp(long number);
};


class vAVITimeStamp
{
public:
  long seconds;
  long checksum, milli_sec_high, milli_sec_low;
  char date[20];
  ulong frame_id_low;
  ulong frame_id_high;
  long frame_number;
  unsigned char frame_id_digits[64];
  char frame_id_string[22];

  void Print();
};


#endif // VASSILIS_READ_AVI_H

