#ifndef VASSILIS_VIDEO_COMMON_H
#define VASSILIS_VIDEO_COMMON_H


#include "video_file.h"

typedef vVideoFile class_sequence;

vVideoFile * vOpenReadVideoFile(const char * filename);

static inline class_sequence * open_read_sequence (const char* filename)
{
  return vOpenReadVideoFile(filename);
}

vVideoFile * vOpenWriteVideoFile(const char * sequence_name, 
                                   long rows, long cols);

static inline class_sequence * open_write_sequence (const char* filename, long rows, long columns)
{
  return vOpenWriteVideoFile(filename, rows, columns);
}

vVideoFile * vOpenWriteVideoFile(const char * sequence_name, 
                                   long rows, long cols, 
                                   long rate, long scale, long color_bytes);

static inline vVideoFile * open_write_sequence(const char * sequence_name, 
                                   long rows, long cols, 
                                   long rate, long scale, long color_bytes)
{
  return vOpenWriteVideoFile(sequence_name, rows, cols, rate, scale, color_bytes);
}

void vCloseVideoFile(vVideoFile * sequence);

static inline void close_sequence (class_sequence * sequence)
{
  vCloseVideoFile(sequence);
}



long vWriteVideo(vVideoFile * output, const char * input_file);


#endif // VASSILIS_VIDEO_COMMON_H
