#include "stdafx.h"

#include "video_file.h"
#include "definitions.h"


vVideoFile::vVideoFile()
{
  fp = 0;
  rows = -1;
  cols = -1;
  number_of_frames = -1;
  rate = -1;
  scale = -1;

  current_frame = -1;
  current_position = -1;
  
  top = -1;
  left = -1;
  height = -1;
  width = -1;
  is_valid = 0;
  is_readable = 0;
  is_writable = 0;
}


vVideoFile::~vVideoFile()
{
  vdelete2(filename);
  is_valid = 0;
  is_readable = 0;
  is_writable = 0;
}


long vVideoFile::SetBounds(long t, long l, long h, long w)
{
  // Make sure that the bounds described by the arguments are not getting
  // out of the region of the frame.
  if ((t >= 0) && (t < rows) &&
      (l >= 0) && (l < cols) &&
      (h > 0) && (t + h <= rows) &&
      (w > 0) && (l+w <= cols))
  {
    top = t;
    left = l;
    height = h;
    width = w;
    return 1;
  }
  else return 0;
}


general_image * vVideoFile::ReadImage(long number)
{
  color_image * the_image = ReadFrame(number);
  return the_image;
}


general_image * vVideoFile::ReadNextImage()
{
  color_image * the_image = ReadNextFrame();
  return the_image;
}
