#ifndef VASSILIS_INTERPRETER_H
#define VASSILIS_INTERPRETER_H


#include "interpreter4.h"
#include "basics/base_interpreter.h"

class vInterpreter : public vInterpreter4
{
public:
  vInterpreter(class_interpreter* in_interpreter) :
  vInterpreter4 (in_interpreter)
  {
  }

  ~vInterpreter() {}

  ushort ProcessKey(char command);
  ushort ProcessMouseClick(long button_down, long row, long col);

  // The main job of InteractiveExecuteProgram is to read the rest
  // of the "command line" arguments, and then call vExecuteProgram,
  // which determines which function should be called.
  // See more comments on the header file interface_programs.h.
  long InteractiveExecuteProgram();
};


class class_gesture_module : public vInterpreter
{
protected:
  // the next two lines are mandatory for any module
  typedef long (class_gesture_module::*type_procedure) ();
  std::vector<type_procedure> procedures;

public:

  //////////////////////////////////////////////////////////
  //                                                      //
  // start of obligatory member functions for any module  //
  //                                                      //
  //////////////////////////////////////////////////////////

  class_gesture_module(class_interpreter * interpreter,
                       vGestureInterfaceGlobals * globals);
  virtual ~class_gesture_module();
  
  virtual long initialize();
  virtual long clean_up();
  
  long enter_command(char * command, type_procedure procedure);
  virtual long process_command(const char * command);
  long sort_commands ();

  //////////////////////////////////////////////////////////
  //                                                      //
  //  end of obligatory member functions for any module   //
  //                                                      //
  //////////////////////////////////////////////////////////

};

#endif // VASSILIS_INTERPRETER_H
