#ifndef VASSILIS_MATCHING_H
#define VASSILIS_MATCHING_H

#include "basics/image.h"
#include "basics/algebra.h"
#include "basics/rle_encoding.h"
#include "virtual_hand/FrameViewFinder.h"
#include "gestures/algorithms.h"
#include "gestures/ranking.h"


long vMatchBinaryImages(grayscale_image * gray1, grayscale_image * gray2);

long vFastMatch(vRLE_Binary * rle1, vRLE_Binary * rle2, long rows, long cols);

long * vFastBinaryMatch(vRLE_Image * image1, vRLE_Sequence * sequence);

vMatchScores *
vEdgeOrientationRanks(vMatrix<double> * training,
                       vMatrix<double> * test,
                       vMatchScores * prefiltered,
                       long number_to_keep);

// Here, instead of trying all possible starts to make the cumulative histogram,
// we only try a couple.
vMatchScores *
vEdgeOrientationRanksFast(vMatrix<double> * training,
                           vMatrix<double> * test,
                           vMatchScores * prefiltered,
                           long number_to_keep);


#endif // VASSILIS_MATCHING_H

