// interfaceDlg.cpp : implementation file
//

#include "stdafx.h"
#include "interface.h"
#include "thesis_interfaceDlg.h"

#include "local_data.h"
#include "basics/read_avi.h"
#include "basics/image.h"
#include "pc_aux.h"
#include "mfc_aux.h"
#include "window.h"

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

#ifndef IDC_KEY_COMMAND
static long IDC_KEY_COMMAND = IDC_FRAME_RATE;
#endif


class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDlg dialog

CInterfaceDlg::CInterfaceDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CInterfaceDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CInterfaceDlg)
	m_frame_info = _T("");
	m_pixel_info = _T("");
	m_key_command = _T("");
	m_frame_slider = 0;
	m_text_output = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

  base_interpreter = 0;
  base_module = 0;
  the_thesis_module = 0;
  graphics_module = 0;


  play_video_flag = 0;
  play_video_script = 0;
}

void CInterfaceDlg::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  //{{AFX_DATA_MAP(CInterfaceDlg)
  DDX_Text(pDX, IDC_FRAME_INFO, m_frame_info);
  DDX_Text(pDX, IDC_PIXEL_INFO, m_pixel_info);
  DDX_Text(pDX, IDC_KEY_COMMAND, m_key_command);
  DDX_Slider(pDX, IDC_FRAME_SLIDER, m_frame_slider);
  //}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CInterfaceDlg, CDialog)
	//{{AFX_MSG_MAP(CInterfaceDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_AMPLIFY_IMAGE, OnAmplifyImage)
	ON_BN_CLICKED(IDC_BLUR, OnBlur)
	ON_BN_CLICKED(IDC_CALCULATE_MOTION, OnComputeMotion)

//	ON_BN_CLICKED(IDC_CHDIR, OnChdir)
	ON_BN_CLICKED(IDC_LOAD_RAW, OnLoadRaw)
	
	ON_BN_CLICKED(IDC_DETECT_SKIN, OnDetectSkin)
	ON_BN_CLICKED(IDC_FIND_EDGES, OnUndirectedEdges)
	ON_BN_CLICKED(IDC_FIND_FACES, OnDetectFaces)
	ON_BN_CLICKED(IDC_FIND_HANDS, OnFindHands)
	ON_BN_CLICKED(IDC_JUMP_IN_SEQUENCE, OnJumpInSequence)
	ON_BN_CLICKED(IDC_STOP_VIDEO, OnStopVideo)
	ON_BN_CLICKED(IDC_MULTIPLY_IMAGE, OnMultiplyImage)
	ON_BN_CLICKED(IDC_NEXT_IMAGE, OnMoveSequence)
	ON_BN_CLICKED(IDC_PREVIOUS_IMAGE, OnPreviousImage)
	ON_BN_CLICKED(IDC_RESIZE_WINDOW, OnResizeWindow)
	ON_BN_CLICKED(IDC_SAVE_IMAGE, OnSaveImage)
	ON_BN_CLICKED(IDC_SKIN_HISTOGRAM_SELECTION, OnRemoveInput)
	ON_BN_CLICKED(IDC_STEP_BACKWARD, OnStepBackward)
	ON_BN_CLICKED(IDC_STEP_FORWARD, OnStepForward)
	ON_BN_CLICKED(IDC_THRESHOLD_IMAGE, OnThresholdImage)
	ON_WM_KEYDOWN()
	ON_WM_KILLFOCUS()
	ON_EN_CHANGE(IDC_KEY_COMMAND, OnChangeKeyCommand)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_NOTIFY(NM_CUSTOMDRAW, IDC_FRAME_SLIDER, OnCustomdrawFrameSlider)
  ON_BN_CLICKED(IDC_PLAY_VIDEO, OnPlayVideo)
	ON_WM_SIZE()
	ON_BN_CLICKED(IDC_STEP_BACKWARD2, OnPreviousInput)
	ON_BN_CLICKED(IDC_STEP_FORWARD2, OnNextInput)
	ON_BN_CLICKED(IDC_REDRAW, OnRedraw)
	ON_BN_CLICKED(IDC_RESIZE_WINDOW2, OnAddFrame)
	ON_BN_CLICKED(IDC_DECREASE_RESOLUTION, OnDecreaseResolution)
	ON_BN_CLICKED(IDC_INCREASE_RESOLUTION, OnIncreaseResolution)
  ON_WM_TIMER()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDlg message handlers


BOOL CInterfaceDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	InitializeInterpreter();
  lbutton_down = 0;
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CInterfaceDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CInterfaceDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
    if (graphics_module == 0)
    {
      return;
    }
		graphics_module->RedrawImages();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CInterfaceDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


LRESULT CInterfaceDlg::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	return CDialog::WindowProc(message, wParam, lParam);}

void CInterfaceDlg::OnLoad() 
{
  char * init_file = vJoinPaths(sequences_directory, "sequence.avi");

 	vector<CString> filenames;
  vGetFilenames(init_file, sequence_filter, &filenames);
  delete [] init_file;

  long length = filenames.size();
  long i;
  for (i = 0; i < length; i++)
  {
    char * filename = filenames[i].GetBuffer(0);
	  if (strcmp(filename, "") == 0) return;
	  long success = graphics_module->AddInput(filename);
    
    // For one of my image sequence formats, i.e. for V_BMP_Sequence,
    // the actual filename is a directory name. V_GetFilenames uses
    // the Windows file dialog, which won't let me select directories.
    // For such files, I will instead enter on the dialog a name
    // like sequence.bmpseq.d, but I will really want sequence.bmpseq
    // to be loaded. This is the point where I take care of that.
    if ((success == 0) && (vStringCaseEndsIn(filename, ".d")))
    {
      char * new_filename = vRemoveEnding(filename);
      graphics_module->AddInput(new_filename);
      vdelete2(new_filename);
    }
  }

  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnAmplifyImage() 
{
  graphics_module->AmplifyImage();
  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnBlur() 
{
	graphics_module->Blur();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnComputeMotion() 
{
	graphics_module->ComputeMotion();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnLoadRaw() 
{
#ifdef VASSILIS_SIEMENS
  char * init_file = vJoinPaths(sequences_directory, "sequence.avi");

 	vector<CString> filenames2;
  vGetFilenames(init_file, "", &filenames2);
  delete [] init_file;

  long length = filenames2.size();
  vector <char*> filenames;

  long i;
  for (i = 0; i < length; i++)
  {
    char * filename = filenames2[i].GetBuffer(0);
    filenames.push_back(function_copy_string (filename));
  }

  graphics_module->load_raw_data (& filenames);
  function_erase_string_vector (&filenames);
#endif // VASSILIS_SIEMENS

  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}


void CInterfaceDlg::OnDetectSkin() 
{
	the_thesis_module->DetectSkin();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnUndirectedEdges() 
{
	graphics_module->UndirectedEdges();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnDetectFaces() 
{
}

void CInterfaceDlg::OnFindHands() 
{
}

void CInterfaceDlg::OnJumpInSequence() 
{
	graphics_module->SetCurrentCounter();
	graphics_module->ShowCurrentFrame();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnStopVideo() 
{
  play_video_flag = 0;
  graphics_module->JumpToFrame(0);
  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnMultiplyImage() 
{
	graphics_module->MultiplyImage();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnMoveSequence() 
{
	graphics_module->MoveSequenceWithClick();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

// This actually should be called OnWriteSequence
void CInterfaceDlg::OnPreviousImage() 
{
  char * init_name = vJoinPaths(sequences_directory, "output.avi");
  CString file_string = vGetFilenameWrite(init_name, sequence_filter);
  vdelete2(init_name);
  char * filename = file_string.GetBuffer(0);
  graphics_module->AddOutput(filename);

  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

// This should be called OnFinishSequence
void CInterfaceDlg::OnResizeWindow() 
{
  graphics_module->RemoveCurrentOutput();
}


void CInterfaceDlg::OnSaveImage() 
{
	graphics_module->SaveImage();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnRemoveInput() 
{
	graphics_module->RemoveCurrentInput();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnStepBackward() 
{
	graphics_module->PreviousInSequence();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnStepForward() 
{
	graphics_module->NextInSequence();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnThresholdImage() 
{
	graphics_module->ThresholdCurrentImage();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags) 
{
	AfxMessageBox("Enter");
	//CDialog::OnKeyDown(nChar, nRepCnt, nFlags);

	char buffer[200];
	//if (nRepCnt <= 0)
	{
		sprintf(buffer, "%character = %c, count = %li", nChar, nRepCnt);
		AfxMessageBox(buffer);
	}
}

BOOL CInterfaceDlg::OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult) 
{
	return CDialog::OnNotify(wParam, lParam, pResult);
}

BOOL CInterfaceDlg::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	return CDialog::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}

void CInterfaceDlg::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);
}

void CInterfaceDlg::InitializeInterpreter()
{
  printf("Running...\n");
  CWnd * temp_frame_info = GetDlgItem(IDC_FRAME_INFO);
	CWnd * temp_pixel_info = GetDlgItem(IDC_PIXEL_INFO);
	CString * frame_info_text = &m_frame_info;
	CString * pixel_info_text = &m_pixel_info;
  graphical_interface_globals globals;
	globals.frame_info_window = new vWindow(temp_frame_info, frame_info_text, this);
	globals.pixel_info_window = new vWindow(temp_pixel_info, pixel_info_text, this);
	globals.window = new vWindow(this);
  globals.window->GetSize();
  globals.window->Resize(790, 1135);
	globals.extra_height = 150;
	globals.min_width = 700;

  base_interpreter = new class_interpreter ();

  base_module = new class_base_module(base_interpreter);
  base_interpreter->enter_module(base_module, "base_module");

  the_thesis_module = new thesis_module(base_interpreter);
  base_interpreter->enter_module(the_thesis_module, "the_thesis_module");

  graphics_module = new graphical_module(base_interpreter, & globals);
  base_interpreter->enter_module(graphics_module, "graphics_module");
  the_thesis_module->graphics_module = graphics_module;

  base_interpreter->check_command_duplicates();
  timer_number = SetTimer(1, 20, 0);
}


void CInterfaceDlg::OnChangeKeyCommand() 
{
	// TODO: If this is a RICHEDIT control, the control will not
	// send this notification unless you override the CDialog::OnInitDialog()
	// function and call CRichEditCtrl().SetEventMask()
	// with the ENM_CHANGE flag ORed into the mask.
	static char last_command;


  static long first_time = 0;
  if (first_time == 0)
  {
    void * pointer = (void*) &m_hWnd;
    specify_application_window (pointer);
    first_time = 1;
  }
  
// debugging
//  static long number = 0;
//  number = number + 1;
//  if (number % 100 == 0)
//  {
//    number = number + 1;
//  }

	char * buffer = m_key_command.GetBuffer(0);
	UpdateData(TRUE);
	buffer = m_key_command.GetBuffer(0);

	long length = strlen(buffer);
  if (length == 0)
  {
    return;
  }
  last_command = buffer[0];
  long max_length = Min(length, (long) 0);

  for (long i = 0; i < max_length; i++)
  {
    buffer[i] = buffer[i+1];
  }
  buffer[max_length] = 0;

	ushort quit = graphics_module->ProcessKey(last_command);
  vMainWindowToForeground();
	UpdateData(FALSE);
  if (quit == 1)
  {
    vConsoleToForeground();
    vdelete (base_interpreter);
    vdelete (base_module);
    vdelete (the_thesis_module);
    vdelete (graphics_module);
    exit(0);
  }
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	lbutton_down = 1;
	long row = point.y;
	long col = point.x;
	
	CDialog::OnLButtonDown(nFlags, point);
	graphics_module->ProcessMouseClick(lbutton_down, point.y, point.x);
  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	lbutton_down = 0;
	
	CDialog::OnLButtonUp(nFlags, point);
	graphics_module->ProcessMouseClick(2+lbutton_down, point.y, point.x);

  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	long row = point.y;
	long col = point.x;
	if (lbutton_down)	graphics_module->ProcessMouseClick(4+lbutton_down, row, col);
	
	CDialog::OnMouseMove(nFlags, point);
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnCustomdrawFrameSlider(NMHDR* pNMHDR, LRESULT* pResult) 
{
	static long last_value = 0;
	UpdateData(TRUE);
	if (last_value != m_frame_slider)
	{
  	graphics_module->SetCurrentCounterPercent(m_frame_slider);
	  graphics_module->ShowCurrentFrame();
		last_value = m_frame_slider;
	}
	
	*pResult = 0;
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnPlayVideo() 
{
  play_video_flag = 1 - play_video_flag;
  CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
  SetFrameRate();
	text_input_window->SetFocus();
}


void CInterfaceDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
  if (graphics_module == 0) return;
  vWindow * window = graphics_module->GetWindow();
  window->GetSize();
}

void CInterfaceDlg::OnPreviousInput() 
{
	graphics_module->PreviousInput();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnNextInput() 
{
	graphics_module->NextInput();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnRedraw() 
{
  graphics_module->RedrawWindow();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnAddFrame() 
{
	graphics_module->write_frame();
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnDecreaseResolution() 
{
  OnEnterIdle(0,0);
  graphics_module->DecreaseResolution();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();
}

void CInterfaceDlg::OnIncreaseResolution() 
{
  graphics_module->IncreaseResolution();	
	CWnd * text_input_window = this->GetDlgItem(IDC_KEY_COMMAND);
	text_input_window->SetFocus();	
}


void CInterfaceDlg::OnTimer(UINT nIDEvent)
{
	UpdateData(TRUE);
  char * buffer = m_key_command.GetBuffer(0);
  if (play_video_flag != 0)
  {
    // debug viz
    // graphics_module->Trash();
    graphics_module->NextInSequence();
    buffer[0] = 0;
	  UpdateData(FALSE);
  }
  
	long length = strlen(buffer);
  if (length == 0)
  {
    return;
  }

  char last_command = buffer[0];
  buffer[0] = 0;
	UpdateData(FALSE);

	ushort quit = graphics_module->ProcessKey(last_command);
  vMainWindowToForeground();
  if (quit == 1)
  {
    vConsoleToForeground();
    vdelete (base_interpreter);
    vdelete (base_module);
    vdelete (the_thesis_module);
    vdelete (graphics_module);
    exit(0);
  }

//	CWnd * text_input_window = GetDlgItem(IDC_KEY_COMMAND);
//	text_input_window->SetFocus();
}


void CInterfaceDlg::SetFrameRate()
{
  static long last_value = -1;

  long frame_rate = graphics_module->get_frame_rate();
  if (frame_rate == last_value)
  {
    return;
  }

  last_value = frame_rate;
  KillTimer(timer_number);
  SetTimer(1, 1000/frame_rate, 0);
}
