// mnist_interfaceDlg.h : header file
//

#if !defined(AFX_INTERFACEDLG_H__2802E537_5CFF_11D4_809C_00C04F09CAEE__INCLUDED_)
#define AFX_INTERFACEDLG_H__2802E537_5CFF_11D4_809C_00C04F09CAEE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "basics/base_interpreter.h"
#include "basics/graphical_module.h"
#include "gestures/thesis_module.h"

/////////////////////////////////////////////////////////////////////////////
// CInterfaceDlg dialog

class CInterfaceDlg : public CDialog
{
// Construction
public:
	CInterfaceDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CInterfaceDlg)
	enum { IDD = IDD_INTERFACE_DIALOG };
	CString	m_frame_info;
	CString	m_pixel_info;
	CString	m_key_command;
	int		m_frame_slider;
	CString	m_text_output;
  //}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CInterfaceDlg)
	public:
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	virtual BOOL OnNotify(WPARAM wParam, LPARAM lParam, LRESULT* pResult);
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CInterfaceDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnLoad();
	afx_msg void OnAmplifyImage();
	afx_msg void OnBlur();
	afx_msg void OnComputeMotion();
	afx_msg void OnLoadRaw();
	afx_msg void OnDetectSkin();
	afx_msg void OnUndirectedEdges();
	afx_msg void OnDetectFaces();
	afx_msg void OnFindHands();
	afx_msg void OnJumpInSequence();
	afx_msg void OnStopVideo();
	afx_msg void OnMultiplyImage();
	afx_msg void OnMoveSequence();
	afx_msg void OnPreviousImage();
	afx_msg void OnResizeWindow();
	afx_msg void OnSaveImage();
	afx_msg void OnRemoveInput();
	afx_msg void OnStepBackward();
	afx_msg void OnStepForward();
	afx_msg void OnThresholdImage();
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	afx_msg void OnChangeKeyCommand();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnCustomdrawFrameSlider(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnPlayVideo();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPreviousInput();
	afx_msg void OnNextInput();
	afx_msg void OnRedraw();
	afx_msg void OnAddFrame();
	afx_msg void OnDecreaseResolution();
	afx_msg void OnIncreaseResolution();
//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

protected:
	unsigned short lbutton_down;

  long play_video_flag;
  char* play_video_script;

  class_interpreter * base_interpreter;
  class_base_module * base_module;
  graphical_module * graphics_module;
  thesis_module * the_thesis_module;

#endif

  UINT_PTR timer_number;

public:
  void InitializeInterpreter();

  void OnTimer(UINT nIDEvent);

  // we override OnOK and OnCancel so that the program does not quit
  // when we hit ENTER or ESC.
  void OnOK()
  {
  }

  void OnCancel()
  {
  }

  void SetFrameRate();
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

//#endif // !defined(AFX_INTERFACEDLG_H__2802E537_5CFF_11D4_809C_00C04F09CAEE__INCLUDED_)
